package cn.ezhizao.project.business.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 辅料管理对象 biz_accessories
 *
 * @author ezhizao
 * @date 2024-09-09
 */
@Data
@TableName(value = "biz_accessories")
public class BizAccessories extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 辅料编号 */
    @Excel(name = "辅料编号")
    @ApiModelProperty(value = "辅料编号")
    private String accessoriesCode;

    /** 账号 */
    @Excel(name = "账号")
    @ApiModelProperty(value = "账号")
    private String itype;

    /** 主管部门 */
    @Excel(name = "主管部门")
    @ApiModelProperty(value = "主管部门")
    private String cusven;

    /** 物料描述 */
    @Excel(name = "物料描述")
    @ApiModelProperty(value = "物料描述")
    private String description;

    /** 采购单位 */
    @Excel(name = "采购单位")
    @ApiModelProperty(value = "采购单位")
    private String unit;

    /** 建立者 */
    @Excel(name = "建立者")
    @ApiModelProperty(value = "建立者")
    private String cruser;

    /** 修改日期 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "修改日期", width = 30, dateFormat = "yyyy-MM-dd")
    @ApiModelProperty(value = "修改日期")
    private Date mddate;

    /** 修改者 */
    @Excel(name = "修改者")
    @ApiModelProperty(value = "修改者")
    private String mduser;

    /** 换算单位 */
    @Excel(name = "换算单位")
    @ApiModelProperty(value = "换算单位")
    private String pouom;

    /** 环保大类码501\502\503\504 */
    @Excel(name = "环保大类码501\502\503\504")
    @ApiModelProperty(value = "环保大类码501\502\503\504")
    private String htype;

    /** 环保大类简称 */
    @Excel(name = "环保大类简称")
    @ApiModelProperty(value = "环保大类简称")
    private String htyna;

    /** 操作者 */
    @Excel(name = "操作者")
    @ApiModelProperty(value = "操作者")
    private String writeruser;

    /** 月用量 */
    @Excel(name = "月用量")
    @ApiModelProperty(value = "月用量")
    private BigDecimal monthUseAmount;

    /** 类别 备库物资 */
    @Excel(name = "类别 备库物资")
    @ApiModelProperty(value = "类别 备库物资")
    private String ltype;

    /** 交货天数 */
    @Excel(name = "交货天数")
    @ApiModelProperty(value = "交货天数")
    private Long deliveryDate;

    /** 安全库存量 */
    @Excel(name = "安全库存量")
    @ApiModelProperty(value = "安全库存量")
    private BigDecimal safetyStock;

    /** 单价 */
    @Excel(name = "单价")
    @ApiModelProperty(value = "单价")
    private BigDecimal price;

    /** NA 正常FM封存 CL 停用 */
    @Excel(name = "NA 正常FM封存 CL 停用")
    @ApiModelProperty(value = "NA 正常FM封存 CL 停用")
    private String status;

    /** 建立日期 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "建立日期", width = 30, dateFormat = "yyyy-MM-dd")
    @ApiModelProperty(value = "建立日期")
    private Date crdate;

    /** 环保标志Y-有环保要求N-无 */
    @Excel(name = "环保标志Y-有环保要求N-无")
    @ApiModelProperty(value = "环保标志Y-有环保要求N-无")
    private String ecoMark;

    /** 单位换算比例 */
    @Excel(name = "单位换算比例")
    @ApiModelProperty(value = "单位换算比例")
    private BigDecimal conversionRatio;

    /** 更新日期 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "更新日期", width = 30, dateFormat = "yyyy-MM-dd")
    @ApiModelProperty(value = "更新日期")
    private Date writedate;

    /** 包装箱尺寸 */
    @Excel(name = "包装箱尺寸")
    @ApiModelProperty(value = "包装箱尺寸")
    private String packageStandard;

    /** 美捷原系统物料编码 */
    @Excel(name = "美捷原系统物料编码")
    @ApiModelProperty(value = "美捷原系统物料编码")
    private String ypart;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal yamt;

    /** 当月加权平均单价（未税） */
    @Excel(name = "当月加权平均单价", readConverterExp = "未=税")
    @ApiModelProperty(value = "当月加权平均单价")
    private BigDecimal monthAvgPrice;

    /** 可变费/固定费=K/G */
    @Excel(name = "可变费/固定费=K/G")
    @ApiModelProperty(value = "可变费/固定费=K/G")
    private String ftype;

    /** 领用计费形式整体/天数/产量(Z/T/C)整体就是不可分割领用后全部消耗 */
    @Excel(name = "领用计费形式整体/天数/产量(Z/T/C)整体就是不可分割领用后全部消耗")
    @ApiModelProperty(value = "领用计费形式整体/天数/产量(Z/T/C)整体就是不可分割领用后全部消耗")
    private String ktype;

    /** 标准寿命天数:从领用日起开始计算使用天数(按月计算) */
    @Excel(name = "标准寿命天数:从领用日起开始计算使用天数(按月计算)")
    @ApiModelProperty(value = "标准寿命天数:从领用日起开始计算使用天数(按月计算)")
    private Long ktyts;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String facno;

    /** 租户id */
    @ApiModelProperty(value = "${comment}")
    private Long tenantId;

}
