package cn.ezhizao.project.business.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * 产品管理对象 biz_product
 *
 * @author ezhizao
 * @date 2023-11-13
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class BizProductAccessoriesMaterial extends BaseEntity
{
    private static final long serialVersionUID = 1L;
    //产品

    /** 料号 */
    /** 隶属厂别（租户id） */
    @ApiModelProperty(value = "${comment}")
    private Long tenantId;

    /** 料号 */
    @Excel(name = "料号")
    @ApiModelProperty(value = "料号")
    private String productCode;

    /** 预入仓库 */
    @Excel(name = "预入仓库")
    @ApiModelProperty(value = "预入仓库")
    private String preStock;

    /** 类别9:成品8:半成品 */
    @Excel(name = "类别9:成品8:半成品")
    @ApiModelProperty(value = "类别9:成品8:半成品")
    private String type;

    /** 轴类型大类id */
    @ApiModelProperty(value = "类别9:成品8:半成品")
    private Long shaftBroadCategoryId;

    /** 轴类型大类A=视窗系统零部件B=动力系统零部件C=车身及底盘系统零部件D=工业精密零部件 */
    @Excel(name = "轴类型大类A=视窗系统零部件B=动力系统零部件C=车身及底盘系统零部件D=工业精密零部件")
    @ApiModelProperty(value = "轴类型大类A=视窗系统零部件B=动力系统零部件C=车身及底盘系统零部件D=工业精密零部件")
    private String shaftBroadCategoryCode;

    /** 轴类型id */
    @ApiModelProperty(value = "轴类型大类A=视窗系统零部件B=动力系统零部件C=车身及底盘系统零部件D=工业精密零部件")
    private Long shaftCategoryId;

    /** 轴类型 */
    @Excel(name = "轴类型")
    @ApiModelProperty(value = "轴类型")
    private String shaftCategoryCode;

    /** 规格,不允许出现下划线_ */
    @Excel(name = "规格,不允许出现下划线_")
    @ApiModelProperty(value = "规格,不允许出现下划线_")
    private String specification;

    /** 图号,不允许出现下划线_ */
    @Excel(name = "图号,不允许出现下划线_")
    @ApiModelProperty(value = "图号,不允许出现下划线_")
    private String drawingNumber;

    /** =客户简称_图号_规格 */
    @Excel(name = "=客户简称_图号_规格")
    @ApiModelProperty(value = "=客户简称_图号_规格")
    private String description;

    /** 生产单位（租户id） */
    @ApiModelProperty(value = "=客户简称_图号_规格")
    private Long productionTenantId;

    /** 直径 */
    @Excel(name = "直径")
    @ApiModelProperty(value = "直径")
    private BigDecimal diameter;

    /** 成品长度 */
    @Excel(name = "成品长度")
    @ApiModelProperty(value = "成品长度")
    private BigDecimal lenght;

    /** 厚度 */
    @Excel(name = "厚度")
    @ApiModelProperty(value = "厚度")
    private BigDecimal thickness;

    /** 客户id */
    @ApiModelProperty(value = "厚度")
    private Long companyId;

    /** 客户代号 */
    @Excel(name = "客户代号")
    @ApiModelProperty(value = "客户代号")
    private String companyCode;

    /** 客户集团简称,产品描述用 */
    @Excel(name = "客户集团简称,产品描述用")
    @ApiModelProperty(value = "客户集团简称,产品描述用")
    private String companyAlias;

    /** 材质id */
    @ApiModelProperty(value = "客户集团简称,产品描述用")
    private Long materialId;

    /** 材质编码 */
    @Excel(name = "材质编码")
    @ApiModelProperty(value = "材质编码")
    private String materialCode;

    /** 密度 */
    @Excel(name = "密度")
    @ApiModelProperty(value = "密度")
    private BigDecimal density;

    /** 销售员id */
    @ApiModelProperty(value = "密度")
    private Long salesmanId;

    /** 销售员编码 */
    @Excel(name = "销售员编码")
    @ApiModelProperty(value = "销售员编码")
    private String salesmanCode;

    /** 保管员id（对应sys_user的id） */
    @ApiModelProperty(value = "销售员编码")
    private Long stockKeeperId;

    /** 保管员编码 */
    @Excel(name = "保管员编码")
    @ApiModelProperty(value = "保管员编码")
    private String stockKeeperCode;

    /** 调度员id（对应员工id） */
    @ApiModelProperty(value = "保管员编码")
    private Long dispatcherId;

    /** 调度员编号（对应员工编码） */
    @Excel(name = "调度员编号", readConverterExp = "对=应员工编码")
    @ApiModelProperty(value = "调度员编号")
    private String dispatcherCode;

    /** 产品状态：NA：正常；CL：不用；OP：封存 */
    @Excel(name = "产品状态：NA：正常；CL：不用；OP：封存")
    @ApiModelProperty(value = "产品状态：NA：正常；CL：不用；OP：封存")
    private String productStatusCode;

    /** 产品状态id（对应数据字典id） */
    @ApiModelProperty(value = "产品状态：NA：正常；CL：不用；OP：封存")
    private Long productStatusId;

    /** 生产类型id */
    @ApiModelProperty(value = "产品状态：NA：正常；CL：不用；OP：封存")
    private Long productionTypeId;

    /** 生产类型（Y：样品；N：量产；T：图号升级） */
    @Excel(name = "生产类型", readConverterExp = "Y=：样品；N：量产；T：图号升级")
    @ApiModelProperty(value = "生产类型")
    private String productionTypeCode;

    /** 技术员id（对应sys_user的id） */
    @ApiModelProperty(value = "生产类型")
    private Long technicianId;

    /** 技术员编码 */
    @Excel(name = "技术员编码")
    @ApiModelProperty(value = "技术员编码")
    private String technicianCode;

    /** 创建者编码 */
    @Excel(name = "创建者编码")
    @ApiModelProperty(value = "创建者编码")
    private String creatorCode;

    /** 物料编号 */
    @Excel(name = "物料编号")
    @ApiModelProperty(value = "物料编号")
    private String materialNum;

    //辅料
    /** 辅料编号 */
    @Excel(name = "辅料编号")
    @ApiModelProperty(value = "辅料编号")
    private String accessoriesCode;

    /** 账号 */
    @Excel(name = "账号")
    @ApiModelProperty(value = "账号")
    private String itype;

    /** 主管部门 */
    @Excel(name = "主管部门")
    @ApiModelProperty(value = "主管部门")
    private String cusven;


    /** 采购单位 */
    @Excel(name = "采购单位")
    @ApiModelProperty(value = "采购单位")
    private String unit;

    /** 建立者 */
    @Excel(name = "建立者")
    @ApiModelProperty(value = "建立者")
    private String cruser;

    /** 修改日期 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "修改日期", width = 30, dateFormat = "yyyy-MM-dd")
    @ApiModelProperty(value = "修改日期")
    private Date mddate;

    /** 修改者 */
    @Excel(name = "修改者")
    @ApiModelProperty(value = "修改者")
    private String mduser;

    /** 换算单位 */
    @Excel(name = "换算单位")
    @ApiModelProperty(value = "换算单位")
    private String pouom;

    /** 环保大类码501\502\503\504 */
    @Excel(name = "环保大类码501\502\503\504")
    @ApiModelProperty(value = "环保大类码501\502\503\504")
    private String htype;

    /** 环保大类简称 */
    @Excel(name = "环保大类简称")
    @ApiModelProperty(value = "环保大类简称")
    private String htyna;

    /** 操作者 */
    @Excel(name = "操作者")
    @ApiModelProperty(value = "操作者")
    private String writeruser;

    /** 月用量 */
    @Excel(name = "月用量")
    @ApiModelProperty(value = "月用量")
    private BigDecimal monthUseAmount;

    /** 类别 备库物资 */
    @Excel(name = "类别 备库物资")
    @ApiModelProperty(value = "类别 备库物资")
    private String ltype;

    /** 交货天数 */
    @Excel(name = "交货天数")
    @ApiModelProperty(value = "交货天数")
    private Long deliveryDate;

    /** 安全库存量 */
    @Excel(name = "安全库存量")
    @ApiModelProperty(value = "安全库存量")
    private BigDecimal safetyStock;

    /** 单价 */
    @Excel(name = "单价")
    @ApiModelProperty(value = "单价")
    private BigDecimal price;

    /** NA 正常FM封存 CL 停用 */
    @Excel(name = "NA 正常FM封存 CL 停用")
    @ApiModelProperty(value = "NA 正常FM封存 CL 停用")
    private String status;

    /** 建立日期 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "建立日期", width = 30, dateFormat = "yyyy-MM-dd")
    @ApiModelProperty(value = "建立日期")
    private Date crdate;

    /** 环保标志Y-有环保要求N-无 */
    @Excel(name = "环保标志Y-有环保要求N-无")
    @ApiModelProperty(value = "环保标志Y-有环保要求N-无")
    private String ecoMark;

    /** 单位换算比例 */
    @Excel(name = "单位换算比例")
    @ApiModelProperty(value = "单位换算比例")
    private BigDecimal conversionRatio;

    /** 更新日期 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "更新日期", width = 30, dateFormat = "yyyy-MM-dd")
    @ApiModelProperty(value = "更新日期")
    private Date writedate;

    /** 包装箱尺寸 */
    @Excel(name = "包装箱尺寸")
    @ApiModelProperty(value = "包装箱尺寸")
    private String packageStandard;

    /** 美捷原系统物料编码 */
    @Excel(name = "美捷原系统物料编码")
    @ApiModelProperty(value = "美捷原系统物料编码")
    private String ypart;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal yamt;

    /** 当月加权平均单价（未税） */
    @Excel(name = "当月加权平均单价", readConverterExp = "未=税")
    @ApiModelProperty(value = "当月加权平均单价")
    private BigDecimal monthAvgPrice;

    /** 可变费/固定费=K/G */
    @Excel(name = "可变费/固定费=K/G")
    @ApiModelProperty(value = "可变费/固定费=K/G")
    private String ftype;

    /** 领用计费形式整体/天数/产量(Z/T/C)整体就是不可分割领用后全部消耗 */
    @Excel(name = "领用计费形式整体/天数/产量(Z/T/C)整体就是不可分割领用后全部消耗")
    @ApiModelProperty(value = "领用计费形式整体/天数/产量(Z/T/C)整体就是不可分割领用后全部消耗")
    private String ktype;

    /** 标准寿命天数:从领用日起开始计算使用天数(按月计算) */
    @Excel(name = "标准寿命天数:从领用日起开始计算使用天数(按月计算)")
    @ApiModelProperty(value = "标准寿命天数:从领用日起开始计算使用天数(按月计算)")
    private Long ktyts;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String facno;

    //原料
    /** 助记码 */
    @Excel(name = "助记码")
    @ApiModelProperty(value = "助记码")
    private String mnemonicCode;

    /** 不懂，原表没有注释 */
    @Excel(name = "不懂，原表没有注释")
    @ApiModelProperty(value = "不懂，原表没有注释")
    private String itemtype;

    /** 结构钢类别 */
    @Excel(name = "结构钢类别")
    @ApiModelProperty(value = "结构钢类别")
    private String steelClass;

    /** 代用群码 */
    @Excel(name = "代用群码")
    @ApiModelProperty(value = "代用群码")
    private String repCode;

    /** 像条形码，原表没有注释 */
    @Excel(name = "像条形码，原表没有注释")
    @ApiModelProperty(value = "像条形码，原表没有注释")
    private String barcode;

    /** 账号 */
    @Excel(name = "账号")
    @ApiModelProperty(value = "账号")
    private String prloc;

    /** 部门编号 */
    @Excel(name = "部门编号")
    @ApiModelProperty(value = "部门编号")
    private String dept;
    /** 部门单位 */
    @Excel(name = "部门单位")
    @ApiModelProperty(value = "部门单位")
    private String uom;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String pounit;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal pofact;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String counit;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal cofact;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String sounit;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal sofact;

    /** 计量单位 */
    @Excel(name = "计量单位")
    @ApiModelProperty(value = "计量单位")
    private String wunit;

    /** 毛重/箱 */
    @Excel(name = "毛重/箱")
    @ApiModelProperty(value = "毛重/箱")
    private BigDecimal weight;

    /** 支数/箱 */
    @Excel(name = "支数/箱")
    @ApiModelProperty(value = "支数/箱")
    private Long weigs;

    /** 成品单个坯重 */
    @Excel(name = "成品单个坯重")
    @ApiModelProperty(value = "成品单个坯重")
    private BigDecimal volume;

    /** 切除尾数 */
    @Excel(name = "切除尾数")
    @ApiModelProperty(value = "切除尾数")
    private String rounded;

    /** 图号 */
    @Excel(name = "图号")
    @ApiModelProperty(value = "图号")
    private String draw;

    /** 是否为MPS料品 */
    @Excel(name = "是否为MPS料品")
    @ApiModelProperty(value = "是否为MPS料品")
    private String mpsok;

    /** 计料形式(Y正常N以成品单个坯重来计算用料) */
    @Excel(name = "计料形式(Y正常N以成品单个坯重来计算用料)")
    @ApiModelProperty(value = "计料形式(Y正常N以成品单个坯重来计算用料)")
    private String isstype;

    /** 需求运算 */
    @Excel(name = "需求运算")
    @ApiModelProperty(value = "需求运算")
    private String bypass;

    /** 结构批量 */
    @Excel(name = "结构批量")
    @ApiModelProperty(value = "结构批量")
    private BigDecimal batchqty;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal yield;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String commodity;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String prdline;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String salgrp;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String prcgrp;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String fixmo;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String prpart;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String attrctl;

    /** abc分类 */
    @Excel(name = "abc分类")
    @ApiModelProperty(value = "abc分类")
    private String abc;

    /** abc控制 */
    @Excel(name = "abc控制")
    @ApiModelProperty(value = "abc控制")
    private String abcctl;

    /** 盘点日期 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "盘点日期", width = 30, dateFormat = "yyyy-MM-dd")
    @ApiModelProperty(value = "盘点日期")
    private Date lcydate;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal stdcost;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal material;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal thismaterial;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal prematerial;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal labor;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal thislabor;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal prelabor;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal overhead;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal thisoverhead;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal preoverhead;

    /** 人工权数 */
    @Excel(name = "人工权数")
    @ApiModelProperty(value = "人工权数")
    private BigDecimal varover;

    /** 费用权数 */
    @Excel(name = "费用权数")
    @ApiModelProperty(value = "费用权数")
    private BigDecimal mutqty2;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal avgprc;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String stdctl;

    /** 业务员代码 */
    @Excel(name = "业务员代码")
    @ApiModelProperty(value = "业务员代码")
    private String purchaser;

    /** 规划人 */
    @Excel(name = "规划人")
    @ApiModelProperty(value = "规划人")
    private String planner;

    /** 委外/供应/制造商 */
    @Excel(name = "委外/供应/制造商")
    @ApiModelProperty(value = "委外/供应/制造商")
    private String vendor1;

    /** 安全存量 */
    @Excel(name = "安全存量")
    @ApiModelProperty(value = "安全存量")
    private BigDecimal safqty;

    /** 再订购点 */
    @Excel(name = "再订购点")
    @ApiModelProperty(value = "再订购点")
    private BigDecimal reorder;

    /** 最低委外/订购/制造商 */
    @Excel(name = "最低委外/订购/制造商")
    @ApiModelProperty(value = "最低委外/订购/制造商")
    private BigDecimal minqty;

    /** 最高委外/订购/制造商 */
    @Excel(name = "最高委外/订购/制造商")
    @ApiModelProperty(value = "最高委外/订购/制造商")
    private BigDecimal maxqty;

    /** 委外/订购/制造倍数 */
    @Excel(name = "委外/订购/制造倍数")
    @ApiModelProperty(value = "委外/订购/制造倍数")
    private BigDecimal mutqty;

    /** 供应期间 */
    @Excel(name = "供应期间")
    @ApiModelProperty(value = "供应期间")
    private Integer maxperiod;

    /** 令单合并 */
    @Excel(name = "令单合并")
    @ApiModelProperty(value = "令单合并")
    private String merge;

    /** 固定前置日 */
    @Excel(name = "固定前置日")
    @ApiModelProperty(value = "固定前置日")
    private Integer lead;

    /** 变动前置日 */
    @Excel(name = "变动前置日")
    @ApiModelProperty(value = "变动前置日")
    private Integer duration;

    /** 累计前置日 */
    @Excel(name = "累计前置日")
    @ApiModelProperty(value = "累计前置日")
    private Integer varbase1;

    /** 变动基数 */
    @Excel(name = "变动基数")
    @ApiModelProperty(value = "变动基数")
    private Integer varbase;

    /** 规划品 */
    @Excel(name = "规划品")
    @ApiModelProperty(value = "规划品")
    private String planitem;

    /** 供需政策 */
    @Excel(name = "供需政策")
    @ApiModelProperty(value = "供需政策")
    private String police;

    /** 低阶码 */
    @Excel(name = "低阶码")
    @ApiModelProperty(value = "低阶码")
    private Integer llc;

    /** 库存量 */
    @Excel(name = "库存量")
    @ApiModelProperty(value = "库存量")
    private BigDecimal onhand;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal onorder;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal allocate;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal iqcqty;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String priceflag;

    /** 商品 */
    @Excel(name = "商品")
    @ApiModelProperty(value = "商品")
    private String merchandise;

    /** 批号控制 */
    @Excel(name = "批号控制")
    @ApiModelProperty(value = "批号控制")
    private String lot;

    /** 辅助量控制 */
    @Excel(name = "辅助量控制")
    @ApiModelProperty(value = "辅助量控制")
    private String aux;

    /** 辅助单位 */
    @Excel(name = "辅助单位")
    @ApiModelProperty(value = "辅助单位")
    private String auxunit;

    /** 辅助量 */
    @Excel(name = "辅助量")
    @ApiModelProperty(value = "辅助量")
    private BigDecimal auxqty;

    /** 最近交易日 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "最近交易日", width = 30, dateFormat = "yyyy-MM-dd")
    @ApiModelProperty(value = "最近交易日")
    private Date lsttxdate;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal subor;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal thissubor;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal presubor;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal other;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal thisother;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal preother;

    /** 建档日期 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "建档日期", width = 30, dateFormat = "yyyy-MM-dd")
    @ApiModelProperty(value = "建档日期")
    private Date createdate;

    /** 建档人 */
    @Excel(name = "建档人")
    @ApiModelProperty(value = "建档人")
    private String createuser;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private Date modifydate;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String modifyuser;

    /** R/S */
    @Excel(name = "R/S")
    @ApiModelProperty(value = "R/S")
    private String rs;

    /** 倒扣件 */
    @Excel(name = "倒扣件")
    @ApiModelProperty(value = "倒扣件")
    private String bkitem;

    /** 保税品 */
    @Excel(name = "保税品")
    @ApiModelProperty(value = "保税品")
    private String bond;

    /** 整批发料  */
    @Excel(name = "整批发料 ")
    @ApiModelProperty(value = "整批发料 ")
    private String bissue;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private Integer qclead;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String tfcode;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal stdlabor;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal stdmachine;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal accumlabor;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal accumachine;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal mpsprice;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private BigDecimal mpscost;

    /** 料品大分类 */
    @Excel(name = "料品大分类")
    @ApiModelProperty(value = "料品大分类")
    private String bigclass;

    /** 料品小分类 */
    @Excel(name = "料品小分类")
    @ApiModelProperty(value = "料品小分类")
    private String smlclass;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String potype;

    /** 动力权数 */
    @Excel(name = "动力权数")
    @ApiModelProperty(value = "动力权数")
    private BigDecimal cstDynamical;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String cstFactory;

    /** 设备权数 */
    @Excel(name = "设备权数")
    @ApiModelProperty(value = "设备权数")
    private BigDecimal cstEquipment;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String cstType;

    /** 组件类型 */
    @Excel(name = "组件类型")
    @ApiModelProperty(value = "组件类型")
    private String cstZj;

    /** 模具编号 */
    @Excel(name = "模具编号")
    @ApiModelProperty(value = "模具编号")
    private String cstPartm;

    /** 成品率考核指标 */
    @Excel(name = "成品率考核指标")
    @ApiModelProperty(value = "成品率考核指标")
    private BigDecimal cstKamt;

    /** 技术要求 */
    @Excel(name = "技术要求")
    @ApiModelProperty(value = "技术要求")
    private String jsyq;

    /** 原材料形状代码 */
    @Excel(name = "原材料形状代码")
    @ApiModelProperty(value = "原材料形状代码")
    private String xzcode;

    /** 最近采购价 */
    @Excel(name = "最近采购价")
    @ApiModelProperty(value = "最近采购价")
    private BigDecimal zjunprc;

    /** 0;mid(part,6,3)='000';;2:原材料3：机物料 */
    @Excel(name = "0;mid(part,6,3)='000';;2:原材料3：机物料")
    @ApiModelProperty(value = "0;mid(part,6,3)='000';;2:原材料3：机物料")
    private String purtype;

    /** 材料牌号 */
    @Excel(name = "材料牌号")
    @ApiModelProperty(value = "材料牌号")
    private String phcode;

    /** 原材料规格型号码 */
    @Excel(name = "原材料规格型号码")
    @ApiModelProperty(value = "原材料规格型号码")
    private String xhcode;

    /** 原材料产地1：国产2：进口3：整装进口 */
    @Excel(name = "原材料产地1：国产2：进口3：整装进口")
    @ApiModelProperty(value = "原材料产地1：国产2：进口3：整装进口")
    private String addcode;

    /** 原材料长度 */
    @Excel(name = "原材料长度")
    @ApiModelProperty(value = "原材料长度")
    private String cdcode;

    /** 0:综合类3：普通轴5：粗大轴 */
    @Excel(name = "0:综合类3：普通轴5：粗大轴")
    @ApiModelProperty(value = "0:综合类3：普通轴5：粗大轴")
    private String cptype;

    /** 1:shaft2:wiper shaft3:pivot shaft4:pivot tube */
    @Excel(name = "1:shaft2:wiper shaft3:pivot shaft4:pivot tube")
    @ApiModelProperty(value = "1:shaft2:wiper shaft3:pivot shaft4:pivot tube")
    private String shaft;

    /** 直径 */
    @Excel(name = "直径")
    @ApiModelProperty(value = "直径")
    private BigDecimal dzj;

    /** 成品长度字符型 */
    @Excel(name = "成品长度字符型")
    @ApiModelProperty(value = "成品长度字符型")
    private String lenghts;

    /** 公差长度含刀宽 */
    @Excel(name = "公差长度含刀宽")
    @ApiModelProperty(value = "公差长度含刀宽")
    private BigDecimal gccd;

    /** 成品直径字符型 */
    @Excel(name = "成品直径字符型")
    @ApiModelProperty(value = "成品直径字符型")
    private String dzjs;

    /** 开账期初库存量 */
    @Excel(name = "开账期初库存量")
    @ApiModelProperty(value = "开账期初库存量")
    private BigDecimal onqty;

    /** 客户简称 */
    @Excel(name = "客户简称")
    @ApiModelProperty(value = "客户简称")
    private String khjc;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private Date invdate;

    /** 客户料号 */
    @Excel(name = "客户料号")
    @ApiModelProperty(value = "客户料号")
    private String khpart;

    /** 直料长度 */
    @Excel(name = "直料长度")
    @ApiModelProperty(value = "直料长度")
    private String zlcd;

    /** 技术要求 */
    @Excel(name = "技术要求")
    @ApiModelProperty(value = "技术要求")
    private String jsyq1;

    /** 1:正常①,2:无半成品①②⑤,3:有半成品①②③④⑤ */
    @Excel(name = "1:正常①,2:无半成品①②⑤,3:有半成品①②③④⑤")
    @ApiModelProperty(value = "1:正常①,2:无半成品①②⑤,3:有半成品①②③④⑤")
    private String rkbz;

    /** 华普料号 */
    @Excel(name = "华普料号")
    @ApiModelProperty(value = "华普料号")
    private String hpart;

    /** 炉号 */
    @Excel(name = "炉号")
    @ApiModelProperty(value = "炉号")
    private String luhao;

    /** 客户订单号 */
    @Excel(name = "客户订单号")
    @ApiModelProperty(value = "客户订单号")
    private String orderno;

    /** 包装盒数 */
    @Excel(name = "包装盒数")
    @ApiModelProperty(value = "包装盒数")
    private Integer bzhs;

    /** 三叶商品编码 */
    @Excel(name = "三叶商品编码")
    @ApiModelProperty(value = "三叶商品编码")
    private String spcode;

    /** 客户商品品名 */
    @Excel(name = "客户商品品名")
    @ApiModelProperty(value = "客户商品品名")
    private String spname;

    /** 客户代码 */
    @Excel(name = "客户代码")
    @ApiModelProperty(value = "客户代码")
    private String cust;

    /** 原材料计算直径 */
    @Excel(name = "原材料计算直径")
    @ApiModelProperty(value = "原材料计算直径")
    private BigDecimal yzj;

    /** $column.columnComment */
    @Excel(name = "${comment}", readConverterExp = "$column.readConverterExp()")
    @ApiModelProperty(value = "${comment}")
    private String writeuser;

    /** 钢材分类 */
    @Excel(name = "钢材分类")
    @ApiModelProperty(value = "钢材分类")
    private String dtype;

    /** 最近报销未税单价 */
    @Excel(name = "最近报销未税单价")
    @ApiModelProperty(value = "最近报销未税单价")
    private BigDecimal zjbxprc;


    private Integer category;

    private List<Long> ids;

}
