package cn.ezhizao.project.business.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;

/**
 * 外协商主表
 *
 * @author ezhizao
 * date    2024-04-24
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "biz_supplier")
public class BizSupplier extends BaseEntity {
    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "租户（厂别）id")
    private Long tenantId;

    @Excel(name = "公司编码")
    @ApiModelProperty(value = "公司编码")
    private String code;

    @Excel(name = "公司名称")
    @ApiModelProperty(value = "公司名称")
    private String name;

    @Excel(name = "公司别名")
    @ApiModelProperty(value = "公司别名")
    private String alias;

    @Excel(name = "助记码")
    @ApiModelProperty(value = "助记码")
    private String mnemonicCode;

    @Excel(name = "地区")
    @ApiModelProperty(value = "地区")
    private String region;

    @Excel(name = "送货方式")
    @ApiModelProperty(value = "送货方式：0：自提；1：物流")
    private String deliveryMethod;

    @Excel(name = "结算方式")
    @ApiModelProperty(value = "0：无结算方式，1：按支结算，2：按炉结算")
    private String settlementType;

    @Excel(name = "损耗上限")
    @ApiModelProperty(value = "损耗上限")
    private BigDecimal lossLimit;

    @Excel(name = "备注")
    @ApiModelProperty(value = "备注")
    private String remark;
    private BigDecimal freightPrice;
    @ApiModelProperty("内部外协")
    private Integer isInnerOutsource;
    @TableField(exist = false)
    private String contactName;
    @TableField(exist = false)
    private String contactPhoneNumber;
}
