package cn.ezhizao.project.business.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

/**
 * 部门对象 sys_dept
 *
 * @author ezhizao
 * @date 2025-04-08
 */
@Data
@TableName(value = "sys_dept")
public class SysDept extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 部门id */
    @ApiModelProperty(value = "工段Id")
    private Long deptId;

    /** 是否为企业 0 部门 1 企业 */
    @Excel(name = "是否为企业 0 部门 1 企业")
    private Integer type;

    /** 是否为工段（0：否，1：是）默认0 */
    @Excel(name = "是否为工段", readConverterExp = "0=：否，1：是")
    @ApiModelProperty(value = "是否为工段(0:否，1：是)")
    private String isWorkSection;

    /** 是否分选(0:否，1：是 */
    @Excel(name = "是否分选(0:否，1：是")
    @ApiModelProperty(value = "是否分选(0:否，1：是)")
    private Integer isSortPackaging;

    /** 是否自动分配计划到每个资源组
0: 否 1: 是 */
    @Excel(name = "是否自动分配计划到每个资源组 0: 否 1: 是")
    private Integer autoAllocation;

    /** 开始报工前是否自动解绑载具
0: 否 1: 是 */
    @Excel(name = "开始报工前是否自动解绑载具(0:否，1：是)")
    private Integer autoUnbind;

    /** 是否一机多批
0: 不是  1: 是    */
    @Excel(name = "是否一机多批 0: 不是  1: 是   ")
    @ApiModelProperty(value = "是否一机多批(0:否，1：是)")
    private Integer equimentFlag;

    /** 租户id */
    @ApiModelProperty(value = "厂别id")
    private Long tenantId;

    /** 父部门id */
    @ApiModelProperty(value = "父级Id")
    private Long parentId;

    /** 父部门id */
    private Long workshopId;

    /** 祖级列表 */
    @Excel(name = "祖级列表")
    private String ancestors;

    /** 部门名称 */
    @Excel(name = "部门名称")
    @ApiModelProperty(value = "部门名称")
    private String deptName;

    /** 部门编码 */
    @Excel(name = "部门编码")
    @ApiModelProperty(value = "部门编码")
    private String deptCode;

    /** 部门key值（助记码） */
    @Excel(name = "部门key值", readConverterExp = "助=记码")
    private String deptKey;

    /** 显示顺序 */
    @Excel(name = "显示顺序")
    private Long orderNum;

    /** 负责人 */
    @Excel(name = "负责人")
    private String manager;

    /** 联系电话 */
    @Excel(name = "联系电话")
    private String phone;

    /** 邮箱 */
    @Excel(name = "邮箱")
    private String email;

    /** 部门状态（0正常 1停用） */
    @Excel(name = "部门状态", readConverterExp = "0=正常,1=停用")
    private String status;

    /** 删除标志（0代表存在 2代表删除） */
    private String delFlag;

    /** 是否可以快速报工 */
    @Excel(name = "是否可以快速报工")
    private Integer hasQuick;

    /** 是否集中周转工段（1:是 */
    @Excel(name = "是否集中周转工段", readConverterExp = "是否集中周转工段（1:是")
    private Integer isCentralizedTurnover;

    /** 外协商id */
    @ApiModelProperty(value = "外协商Id")
    private Long supplierId;

    /** 是否发往外协(0:否；1：是 */
    @Excel(name = "是否发往外协(0:否；1：是")
    @ApiModelProperty(value = "是否发往外协(0:否，1：是)")
    private Integer isOutsourcing;
    @TableField(exist = false)
    private Integer isInnerOutsource;

}
