package cn.ezhizao.project.business.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.aspectj.lang.annotation.Excel.ColumnType;
import cn.ezhizao.framework.web.domain.BaseEntity;
import cn.ezhizao.project.system.domain.SysUser;
import com.baomidou.mybatisplus.annotation.TableField;
import lombok.Data;

/**
 * 用户对象 sys_user
 *
 * @author ruoyi
 */
@Data
public class SysDeptUser extends BaseEntity {
    private static final long serialVersionUID = 1L;

    /**
     * 用户ID
     */
    @Excel(name = "用户序号", cellType = ColumnType.NUMERIC, prompt = "用户编号")
    private Long userId;

    private Long tenantId;

    /**
     * 部门ID
     */
    private Long deptId;


    /**
     * 是否主管
     * */
    private String isLeader;

    /**
     * 是否兼职
     * */
    private String isPartTime;


    /**
     * 是否调度
     * */
    private String isDispatcher;

    /**
     * 是否工段长
     * */
    private String isFormman;

    /**
     * 是否调机
     * */
    private String isYardman;

    /**
     * 人员信息
     */
    @TableField(exist = false)
    private SysUser user;

    @TableField(exist = false)
    private String nickName ;
    @TableField(exist = false)
    private String userName ;
    @TableField(exist = false)
    private String deptName ;
    /**
     * 部门信息
     */
    @TableField(exist = false)
    private SysDept dept;
    private Long isTemporary;

}
