package cn.ezhizao.project.business.mapper;

import java.util.List;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import cn.ezhizao.project.business.domain.SysDept;
import org.apache.ibatis.annotations.Param;

/**
 * 部门Mapper接口
 *
 * @author ezhizao
 * @date 2025-04-08
 */
public interface SysDeptMapper extends BaseMapper<SysDept>
{
    /**
     * 查询部门列表
     *
     * @param sysDept 部门
     * @return 部门集合
     */
    public List<SysDept> getList(SysDept sysDept);
    public SysDept checkDeptNameUnique(@Param("deptName") String deptName, @Param("parentId") Long parentId);
    public SysDept checkDeptCodeUnique(@Param("deptCode") String deptCode, @Param("parentId") Long parentId);
    public int insertDept(SysDept dept);
    public int updateDept(SysDept dept);
    public SysDept selectDeptById(Long deptId);
    public int deleteDeptById(Long deptId);
    public List<SysDept> selectChildrenDeptById(Long deptId);
    public int updateDeptChildren(@Param("depts") List<SysDept> depts);
    public List<SysDept> selectDeptList(SysDept dept);
    public int hasChildByDeptId(Long deptId);
    public int checkDeptExistUser(Long deptId);
    public void updateDeptStatusNormal(Long[] deptIds);
    public SysDept getDeptByDeptId(Long deptId);
    public int selectNormalChildrenDeptById(Long deptId);

    /**
     * 物理删除
     * @param sysDept
     * @return 删除结果
    */
    public int physicalDelete(SysDept sysDept);
}
