package cn.ezhizao.project.business.service;

import java.util.List;

import cn.ezhizao.framework.aspectj.lang.annotation.DataScope;
import com.baomidou.mybatisplus.extension.service.IService;
import cn.ezhizao.project.business.domain.SysDept;

/**
 * 部门Service接口
 *
 * @author ezhizao
 * @date 2025-04-08
 */
public interface ISysDeptService extends IService<SysDept>
{
    /**
     * 查询部门列表
     *
     * @param sysDept 部门
     * @return 部门集合
     */
    public List<SysDept> getList(SysDept sysDept);
    public String checkDeptNameUnique(SysDept dept);
    public String checkDeptCodeUnique(SysDept dept);
    public int insertDept(SysDept dept);
    public int updateDept(SysDept dept);
    public boolean hasChildByDeptId(Long deptId);

    List<SysDept> selectDeptList(SysDept dept);

    public boolean checkDeptExistUser(Long deptId);

    SysDept getDeptByDeptId(Long deptId);

    public void checkDeptDataScope(Long deptId);
    public int deleteDeptById(Long deptId);
    public int selectNormalChildrenDeptById(Long deptId);
    /**
     * 物理删除
     * @param sysDept
     * @return 删除结果
     */
    public int physicalDelete(SysDept sysDept);

}
