package cn.ezhizao.project.business.service.impl;

import cn.ezhizao.project.business.domain.BizCompanyProductPackage;
import cn.ezhizao.project.business.mapper.BizCompanyProductPackageMapper;
import cn.ezhizao.project.business.service.IBizCompanyProductPackageService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * 产品包装客户关联Service业务层处理
 *
 * @author ezhizao
 * @date 2024-09-10
 */
@Service
public class BizCompanyProductPackageServiceImpl extends ServiceImpl<BizCompanyProductPackageMapper, BizCompanyProductPackage> implements IBizCompanyProductPackageService
{
    @Resource
    private BizCompanyProductPackageMapper bizCompanyProductPackageMapper;

    /**
     * 查询产品包装客户关联列表
     *
     * @param bizCompanyProductPackage 产品包装客户关联
     * @return 产品包装客户关联
     */
    @Override
    public List<BizCompanyProductPackage> getList(BizCompanyProductPackage bizCompanyProductPackage)
    {
        return bizCompanyProductPackageMapper.getList(bizCompanyProductPackage);
    }

    /**
     * 物理删除
     * @param bizCompanyProductPackage
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizCompanyProductPackage bizCompanyProductPackage){ return bizCompanyProductPackageMapper.physicalDelete(bizCompanyProductPackage); };

}
