package cn.ezhizao.project.tool.swagger.controller;

import cn.ezhizao.project.tool.swagger.dto.Table;
import cn.ezhizao.project.tool.swagger.util.SwaggerParser;
import cn.ezhizao.project.tool.swagger.util.WordGenerator;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
public class SwaggerToWordController {
    @Resource
    SwaggerParser swaggerParser;
    @Resource
    WordGenerator wordGenerator;
    @GetMapping("/getInterfaceDoc")
    public void getInterfaceDoc() {
        String projectPath = "http://192.168.31.126:8083";// 根据实际Swagger地址修改
        String resp = HttpUtil.get(projectPath + "/swagger-resources");
        JSONArray groupJsonArray = JSONArray.parseArray(resp);
        ArrayList<String> groupNames = new ArrayList<>();
        for (Object o : groupJsonArray) {
            JSONObject group = (JSONObject) o;
            groupNames.add(group.getString("name"));
        }

        // 接口信息
        JSONArray apiInfos = new JSONArray();
        groupNames.forEach(group -> {

            Map<String, Object> param = new HashMap<>();
            param.put("group", group);
            String result = HttpUtil.get(projectPath + "/v2/api-docs", param);
            JSONObject jsonObject = JSONObject.parseObject(result);
            jsonObject.put("group",group);
            apiInfos.add(jsonObject);
            System.out.println(jsonObject.getString("group"));
        });
        List<Table> tables = SwaggerParser.generateInterfaceDoc(apiInfos);
        wordGenerator.test(tables);
    }
}